@echo off
REM --------------------------------------------------------------------
REM (C) COPYRIGHT International Business Machines Corp. 2000-2004
REM All Rights Reserved
REM 
REM US Government Users Restricted Rights - Use, duplication or
REM disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
REM
REM NAME:		 installfix.bat
REM
REM FUNCTION:
REM		 install fixes to DB2 Everyplace
REM
REM --------------------------------------------------------------------



@setlocal

set DCONNTYPE=-conntype NONE

REM Arguments:
IF NOT "%1" == "-noRedeployEAR" goto USEADMIN
set NOREDEPLOY=1
shift 

:USEADMIN
IF NOT "%1" == "-useAdminServer" goto ARGS
set DCONNTYPE=
shift
goto ARGS



:ARGS
set USERNAME=%1
shift
set PASSWORD=%1
shift

set DSYINSTDIR=%~sf1
set WASHOME=%~sf2
set FIXDIR=%~sf3
set NODENAME=%4
set SERVERNAME=%5

set WASUSERNAME=%6
set WASPASSWORD=%7



REM Verify some arguments:
if not exist "%DSYINSTDIR%" goto USAGE
if not exist "%WASHOME%" goto USAGE
if not exist "%FIXDIR%" goto USAGE
if "%NODENAME%" == "" goto USAGE
if "%SERVERNAME%" == "" goto USAGE


echo - Please ensure that both the DB2 Everyplace Sync Server and MDAC are stopped
echo   before continuing.
pause


REM backup:
xcopy /e /v /i "%DSYINSTDIR%\Server\bin" "%FIXDIR%\backup\bin"
xcopy /e /v /i "%DSYINSTDIR%\Server\classes" "%FIXDIR%\backup\classes"
xcopy /e /v /i "%DSYINSTDIR%\Server\lib" "%FIXDIR%\backup\lib"
xcopy /e /v /i "%DSYINSTDIR%\Server\properties" "%FIXDIR%\backup\properties"
xcopy /e /v /i "%DSYINSTDIR%\Server\installableApps\common" "%FIXDIR%\backup\Server\installableApps\common"
xcopy /e /v /i "%DSYINSTDIR%\Server\sample" "%FIXDIR%\backup\sample"
      
REM apply fixes:
if exist "%FIXDIR%\Server" xcopy /e /v /i /r /y "%FIXDIR%\Server\*" "%DSYINSTDIR%\Server"
if exist "%FIXDIR%\WAS" xcopy /e /v /i /r /y "%FIXDIR%\WAS\*" "%DSYINSTDIR%\WAS"


if "%NOREDEPLOY%" == "1" goto POST

if not "%WASUSERNAME%" == "" set AUTH=-user "%WASUSERNAME%"
if not "%WASPASSWORD%" == "" set AUTH=%AUTH% -password "%WASPASSWORD%"
if "%WASUSERNAME%" == "" set AUTH=

REM WAS 5:
if exist "%WASHOME%\bin\wsadmin.bat" call "%WASHOME%\bin\wsadmin.bat" %DCONNTYPE% %AUTH% -profile "%DSYINSTDIR%\Server\installableApps\common\dsyDB2eEarEnv.jacl" -f "%DSYINSTDIR%\Server\installableApps\common\dsyInstallDB2eEAR.jacl" "%NODENAME%" "%SERVERNAME%" "%DSYINSTDIR%"

set CMD=set servername %SERVERNAME%
set CMD=%CMD%; set nodename %NODENAME%
set CMD=%CMD%; set server [$AdminConfig getid /Node:${nodename}/Server:${servername}/]
set CMD=%CMD%; setTimeout $server 40 40

if exist "%WASHOME%\bin\wsadmin.bat" call "%WASHOME%\bin\wsadmin.bat" %DCONNTYPE% %AUTH% -profile "%DSYINSTDIR%\Server\installableApps\common\dsyFunctions.jacl" -c "%CMD%"

REM WAS 4:
if exist "%WASHOME%\bin\XMLConfig.bat" call "%WASHOME%\bin\XMLConfig.bat" -adminNodeName %NODENAME% -import "%DSYINSTDIR%\Server\installableApps\common\dsy_was40_install_module.xml" -substitute "node=%NODENAME%;DSYINSTDIR=%DSYINSTDIR%;WAS_ROOT=%WASHOME%"

goto POST


:POST
REM Post install tasks:

db2cmd /i /w /c "%DSYINSTDIR%\Server\bin\dsyctldb.bat" "%USERNAME%" "%PASSWORD%" > "%FIXDIR%\dsyctldb.log"
type "%FIXDIR%\dsyctldb.log"
db2cmd /i /w /c "%DSYINSTDIR%\Server\bin\dsyjdbcmigration.bat" > "%FIXDIR%\dsyjdbcmigration.log"
type "%FIXDIR%\dsyjdbcmigration.log"

goto END

:USAGE
echo Usage:
echo    installfix.bat [ -noRedeployEAR ] [ -useAdminServer ] username password DSYINSTDIR WAS_HOME FIX_DIRECTORY NODENAME SERVERNAME [ WASUSERNAME ] [ WASPASSWORD ]
echo.
echo    The option -noRedeployEAR is only to be used if updating the installed EAR is not desired.
echo    The option -useAdminServer is valid for WAS 5 only. This option is required for WAS ND environments.
echo    WASUSERNAME and WASPASSWORD is used for WAS 5 only, and they are required if security is enabled.
goto EXIT

:END
echo End of fix installation. 

:EXIT

@endlocal
